/*
 *	Generic stuff.
 */


#ifndef HR_GENERAL
#define HR_GENERAL

#include <stdio.h>
#include <vgagl.h>
#include "hr_sound.h"
#include "hr_defines.h"

/* This contains most of the globals used by HobbiRewl */
extern struct {
	unsigned int flags;
	unsigned char    *datapath;
	unsigned char    *fillpattern;
	struct hr_color  *def_colors;
	struct hr_button *firstbutton;
	struct hr_button *default_button;
	struct hr_font   *font8x8;
	struct hr_menu   *firstmenu;
	struct hr_screen *active_screen;
	GraphicsContext  *physicalscreen;
	struct hr_window *firstwindow;
	struct hr_window *active_window;
	struct hr_zone   *firstzone;
	struct hr_bob    *firstbob;
	struct hr_palette *active_palette;
	int def_hotkey;
	int (*def_func)();
	int current_screenmode;
}hr;

extern int pcos[360];
extern int psin[360];

extern void hr_init();
extern void hr_cleanup();
extern void hr_debug_log(unsigned char *text);
extern void hr_default_palette();
extern void hr_error_exit(unsigned char *text);	
extern void hr_replace_chars(unsigned char *where,
									  unsigned char *what,
									  unsigned char *with);
extern unsigned char *hr_percentage_string(unsigned char *target,
														 int min,int max,int def,int val,
														 unsigned char *minstring,
														 unsigned char *maxstring,
														 unsigned char *defstring);
extern double hr_return_angle(double dx,double dy);
extern int    hr_ask_confirmation(unsigned char *question);
#endif
